In this document you will find a list of versions and comments to each of
these. Below the list you will find a more detailed description of whatever
changes there are in the latest version.




Program history (latest version listed first):

23 DEC 1991 - V1.4. Fixed some minor inconsistencies concearning list
		    manipulation (potential Guru attractors!)

		    Better autodetaching. Now uses Eddy Carrol style res()

		    No more need to press RETURN to terminate the WB banner.

		    Dropped support for encrypted datafiles. Who use it
		    anyway?

		    Made PP a lot more robust. Should cope much better with
		    ackward situations such as a request to terminate PP
		    while another process is still executing internal PP
		    code. Still a few things left to do..

		    MAJOR ENHANCEMENT: No more need for powerpacker.library!
		    Uses optimized version of Nico's assembly language
		    decrunch routine.

		    MAJOR ENHANCEMENT: More than 80% faster file loading!
		    (uses customized ppLoadData())

		    Discovered strange bug! Read .DOC file, please!

		    Much better memory management - load & decrunch larger
		    files

		    Simple virus warnings


22 AUG 1991 - V1.3. Made PP behave more politely to the OS. It now works
		    with most patcher-type programs, including VirusX.
		    Thanx Ray!


18 AUG 1991 - V1.2. Added support for AmigaDOS 2.0


08 AUG 1991 - V1.1. PP now works as an on/off switch.
	            Added more error messages.
		    Added workbench support.
	            More intelligent file loading.
	            Temporary decrunch path now selectable.
		    Made detach-startup optional (through #def's)


08 JUL 1991 - V1.0. Initial (beta) release
		    (PP would open a window for you to close when you no
		    longer wanted it to be active. File loading was crude
		    and slow, and PP was only able to use RAM for back-
		    ground file decrunching. Oh, by the way: PP didn't have
		    any error messages either ... )




                      Changes in Powerpacker Patcher

                            Version 1.3 -> 1.4


A.

All  list  manipulation  calls  (AddHead()  &  friends)  are now sandwiched
between Forbid() and Permit() calls.

B.

Pre-1.4  versions  used the Aztec autodetach code.  It worked, but had some
nasty  side  effects.   For  one thing, EndCLI refused to close the window.
Secondly,  if  anything  happened  during  startup,  and PP wanted to print
something,  it  would  appear  after the CLI prompt, which was not a pretty
sight.

V1.4  uses  a  C'ified and debugged version of Eddy Carrols res() function.
Now PP autodetaches correctly (and when it is good and ready for it!)

C.

I've  had  letters  from people complaining about this.  Now, any Workbench
messages displayed by PP will disappear after a few seconds.

D.

During  my  work  to  enhance the overall performance of PP, it soon became
clear  that  encrypted  datafiles  would  be  a big problem.  So after some
consideration, I decided to discontinue the support for encryped datafiles,
as  of PP v1.4.  If anyone out there has some very strong arguments against
this, I'm all ears.

E.

Older  versions terminated more or less at once, without any considerations
to  the  fact  that other processes could quite possibly still be executing
internal PP code.  1.4 should cope much better in such situations.

Further,  PP  now  refuses to terminate if some other process has repatched
its DOS vectors.

F.

It  turned  out that Nico's .fd file for powerpacker.library was incorrect.
I  simply  couldn't  get  his  pp_DecrunchBlock  to work!  So I removed all
references  to  the  library  from  the program, and implemented Nico's own
assembly  decrunch  routine  (v2.0).   I  made a few optimizations here and
there,  and  PP now decrunches faster than Powerpacker itself.  Nothing too
radical - I figure it to be about 15% max.

G.

This  is  a  major one.  Older PP's used the in-library ppLoadData(), which
was  actually a major overkill.  I finally pulled myself together and wrote
my own ppLoadData().  It is customized to suit the special needs of PP, and
so  saves  a lot of Seek()'ing and file opening/closing.  A few basic tests
of  mine  showed  that PP v1.4 was about 80% faster than previous versions.
With WB2.0 the effect is even more outspoken.

H.

This bug is possibly a Workbench bug. Please read "PP.DOC" (BUG section) to
find a more detailed description of this peculiarity.

I.

Also  a major enhancement.  For RAM based decrunch-paths (RAM:, VD0:, RAD:,
RRD:   &  friends),  memory  requirements are now only 10k more than what a
file  unpacks  to.   For  a  file that unpacks to 100k, PP & RAM:  combined
require  some  110k  (peak).  Older versions would temporarily require more
than 200k to do this.

J.

PP will now (optionally) report when anybody changes PP's DOS vectors.  Not
too sophisticated, but it gets the job done.




CONCLUSION

If you have v1.3, throw it away and use v1.4 instead. If you have less than
v1.3, you have my condolences.



